;===============================================================================
; LevelMusic - Super Music Bypass, by ShadowFan-X
;
; This is the file you patch to your ROM.
;
; If you are not an ASM programmer, then move along, nothing to see here.
;===============================================================================
; Configuration stuff
incsrc config.asm

; Validate the setting for !FadeConfig.
assert !FadeConfig >= 0 && !FadeConfig <= 2

; Main hijack
org $00971A
	autoclean JML AssignLevelMusic
	nop

; Music fade hijack
org $00D276
	autoclean JSL LevelMusicFade
	nop

freecode
prot LevelMusicTable

; Identifier byte to make this patch easily detectable.
; A pointer to the music table will always immediately follow.
db "!@LvMusMAIN" : dl LevelMusicTable

; Set the level music
AssignLevelMusic:
	REP #$10	; 16-bit X
	LDX $010B
	LDA.l LevelMusicTable, x
	SEP #$10	; 8-bit X
	BEQ +		; Play default music when set to $00
	CMP #$FF
	BNE ++
	LDA #$00
++	STA $0DDA
	JML $009738
+	LDA $0109
	BEQ +
	JML $00971F
+	JML $009728

; Check if the music for the current level is
; different from the music for the next level.
LevelMusicFade:
if !FadeConfig == 1
	LDA !FadeConfig
	BNE .Return
else
if !FadeConfig == 2
	LDA !FadeConfig
	BEQ .Return
endif
endif
	LDA $5B
	LSR
	BCC +
	LDY $97
	BRA .Continue
+	LDY $95
	.Continue
	LDA $19B8, y
	STA $00
	LDA $19D8, y
	TAX
	AND #$01
	STA $01
	TXA
	REP #$10	; 16-bit X and Y
; See if this is a secondary entrance!
	AND #$02
	BEQ +
	LDX $00
	LDA $05F800, x
	STA $00
	STZ $01
	LDA $05FE00, x
	AND #$08
	BEQ +
	INC $01
; NOW the destination level number is loaded.
+	LDX $00
	LDA.L LevelMusicTable, x
	LDX $010B
	CMP.L LevelMusicTable, x
	SEP #$10	; 8-bit X and Y
	BEQ .Return
if read1($009E18) == $FF
	LDA #$FF	; AddmusicK uses $FF as music fade-out
else
	LDA #$80	; All othere Addmusics (and SMW) use $80
endif
	STA $1DFB
	.Return
	LDA #$0F
	STA $0100
	RTL

; Put music tables in a different data chunk
freedata
db "!@LvMusTBL"
LevelMusicTable:
	incsrc musictables.asm
